searchNodes=[{"doc":"","ref":"rebar3_external.html","title":"rebar3_external","type":"module"},{"doc":"","ref":"rebar3_external.html#init/1","title":"rebar3_external.init/1","type":"function"},{"doc":"","ref":"rebar_external_resource.html","title":"rebar_external_resource","type":"module"},{"doc":"","ref":"rebar_external_resource.html#download/4","title":"rebar_external_resource.download/4","type":"function"},{"doc":"","ref":"rebar_external_resource.html#init/2","title":"rebar_external_resource.init/2","type":"function"},{"doc":"","ref":"rebar_external_resource.html#lock/2","title":"rebar_external_resource.lock/2","type":"function"},{"doc":"","ref":"rebar_external_resource.html#make_vsn/2","title":"rebar_external_resource.make_vsn/2","type":"function"},{"doc":"","ref":"rebar_external_resource.html#needs_update/2","title":"rebar_external_resource.needs_update/2","type":"function"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Added Fixed Changed Removed","ref":"changelog.html#unreleased","title":"Changelog - [Unreleased]","type":"extras"},{"doc":"Fixed Fix the correct git reference when external is a git dependency.","ref":"changelog.html#0-1-1-2023-05-16","title":"Changelog - [0.1.1] - 2023-05-16","type":"extras"},{"doc":"Added Fixed Changed Removed","ref":"changelog.html#0-1-0-2023-05-01","title":"Changelog - [0.1.0] - 2023-05-01","type":"extras"},{"doc":"A rebar3 plugin to get external dependencies.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Add the plugin to the rebar3.config file: { plugins , [ rebar3_external ] } . Next, define some external dependencies that your project will fetch: { deps , [ % Download external dependency from HTTP URL { snappy , { external , { http , &quot;https://github.com/google/snappy/archive/refs/tags/1.1.9.tar.gz&quot; , { md5 , &quot;213b6324b7790d25f5368629540a172c&quot; } } , &quot;c_src&quot; , [ { description , &quot;Google&#39;s Snappy compression library&quot; } , { vsn , &quot;1.1.9&quot; } ] } } , % Clone external dependency from git a repository { leveldb , { external , { git , &quot;https://github.com/basho/leveldb&quot; , { tag , &quot;2.0.38&quot; } } , &quot;c_src&quot; , [ { description , &quot;leveldb: A key-value store&quot; } , { vsn , &quot;2.0.38&quot; } ] } } ] } . It is possible to declare two types of external dependencies: An external HTTP(s) URL pointing to a package file like tar.gz , tar.bz2 , tar.xz . It is mandatory to specify a checksum hex digest which could be a md5 or sha256 A git repository where is possible to use the same git syntax when declaring a git rebar3 For both declaration, it is also necessary to add two extra information like: The destination folder, where the external resource will be fetched. It could be a folder like c_src or any other. However, it is important to note that your custom makefiles should point to the same folder later A property list having description and vsn properties specifying a small description and its version Also, it is necessary to define some hooks for compile and clean . Usually here is where your Makefile is going to be called: { pre_hooks , [ { compile , &quot;make -C c_src compile&quot; } ] } . { post_hooks , [ { clean , &quot;make -C c_src clean&quot; } ] } . That is all the rebar3 configuration needed. The next step is to change the c src/Makefile (or whatever you are using as build tool) to use the fetched source code. By default rebar3 exports an environment variable called: _REBAR_DEPS_DIR and it has the full path to the dependency folder with the current profile being used. So, in the Makefile we have to use that variable like the following: LEVELDB_SRC := $( REBAR_DEPS_DIR ) / leveldb / c_src That way the Makefile will include the correct path. It's done. Now your project is ready to fetch external dependencies. And all rebar3 commands should work as expected: rebar3 get-deps rebar3 compile rebar3 clean rebar3 tree","ref":"readme.html#how-to-use","title":"Overview - How to use","type":"extras"},{"doc":"This plugin is a follow up for Implement hooks for get-deps commands . The intend is to provide a plugin which fetches external dependency (non OTP like dependency, like a library in C for example); so a project can declare any external dependency and get them fetched. For each dependency the plugins creates a &quot;fake&quot; OTP application layout, that is, writing an .src.app into src folder. That way rebar3 &quot;thinks&quot; that the dependency is a real one (this idea is not new and I got it from plugins like rebar_raw_resosurce ). For example, if you declare a dependency such as: { deps , [ { snappy , { external , { http , &quot;https://github.com/google/snappy/archive/refs/tags/1.1.9.tar.gz&quot; , { md5 , &quot;213b6324b7790d25f5368629540a172c&quot; } } , &quot;c_src&quot; , [ { description , &quot;Google&#39;s Snappy compression library&quot; } , { vsn , &quot;1.1.9&quot; } ] } } ] } . Then, this plugin downloads the snappy source code from github's URL and unpack it into _build/default/lib/snappy/c_src folder. Also it stores the download file into _build/default/lib/snappy/1.1.9.tar.gz . description and vsn are used to write a &quot;fake&quot; .app.src into _build/default/lib/snappy/src/snappy.src.app . Moreover, the plugin also stores the downloaded package checksum into a file _build/default/lib/snappy/1.1.9.tar.gz.checksum , that is necessary only for http resources. It's important to note that the plugins does the full rebar3 dependency management, including updating the rebar.lock file. The basic idea is to provide better external (non OTP dependency) for projects that needs to interface with languages like C, C++, Rust, ... Please, check out the rebar3_external_example to check full working example.","ref":"readme.html#how-does-it-work","title":"Overview - How does it work ?","type":"extras"},{"doc":"Release under Apache License 2.0 . Parts of src/rebar_external_resource.erl was based on rebar_raw_resosurce .","ref":"readme.html#license","title":"Overview - License","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS Copyright 2023, João Henrique Ferreira de Freitas &lt;joaohf@gmail.com&gt;. Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"License","type":"extras"}]